import saori;
import std.zip;
import std.path;
import std.file;
import std.stream;

private Eco eco;

class Eco {
private:
    ZipArchive arc = null;
    /// ŌɌt@CێĂ
    char[] filename = null;
    /// ̃JgfBNg
    char[] cwd;
    char[] getfullpath(char[] path)
    {
        if(isabs(path)) return path;
        return std.path.join(this.cwd, path);
    }
public:
    this(char[] cwd)
    {
        this.cwd = cwd;
    }

    bool loadzipfile(char[] file)
    in {
        assert(file != null);
    }
    body {
        char[] fullpath = getfullpath(file);
        if(this.arc !== null && fullpath == this.filename) {
            debug stdout.writeLine("recycle");
            return true;
        }
        this.filename = fullpath;
        this.arc = null;
        try {
            if(!isfile(filename)) {
                filename = null;
                return false;
            }
            this.arc = new ZipArchive(read(filename));
        }
        catch(Exception e) {
            this.filename = null;
            return false;
        }
        return true;
    }

    char[][] list()
    in { assert(this.arc !== null); }
    body {
        return this.arc.directory.keys.sort;
    }

    bool contains(char[] name)
    in { assert(this.arc !== null); }
    body {
        return this.arc.directory[name] !== null;
    }

    bool isnar()
    {
        return this.contains("install.txt");
    }

    bool extract(char[] name, char[] destfile)
    {
        if(!this.contains(name)) return false;
        destfile = this.getfullpath(destfile);
        debug stderr.printf("'%.*s' -> '%.*s'\n", name, destfile);
        // XyVt@C珑Ȃ悤ɂׂB
        try {
            write(destfile, this.arc.expand(this.arc.directory[name]));
        }
        catch(Exception e) {    // FileError, ZipException
            debug e.print();
            return false;
        }
    }
}

extern (C) {
    bool saori_load(char[] path)
    {
        eco = new Eco(path);
        return true;
    }
    bool saori_unload()
    {
        eco = null;
        return true;
    }
    int saori_execute(SaoriRequest req, inout SaoriResponse res)
    {
        try {
        if(req.arguments.length < 2) return 200;

        if(!eco.loadzipfile(req.arguments[0])) {
            res.result = "0";
            return 200;
        }
        switch(req.arguments[1]) {
        case "list":
            res.values = eco.list();
            res.result = toString(res.values.length);
            break;
        case "iszip":
            res.result = "1";
            break;
        case "isnar":
            res.result = toString(cast(int)eco.isnar());
            break;
        case "contains":
            if(req.arguments.length < 3) {
                res.result = "0";
                break;
            }
            char[] name = req.arguments[2];
            res.result = toString(cast(int)eco.contains(name));
            break;
        case "extract":
            if(req.arguments.length < 4) {
                res.result = "0";
                break;
            }
            char[] name = req.arguments[2];
            char[] destfile = req.arguments[3];
            res.result = toString(cast(int)eco.extract(name, destfile));
            break;
        default:
            res.result = "0";
            break;
        }
        }
        catch(Exception e) {
            e.print();
        }
        return 200;
    }
    int saori_getversion(SaoriRequest req, inout SaoriResponse res)
    {
        return 200;
    }
}

